package acheckboxwrapper;

import com.example.checkbox.BBox;

import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.BA.DependsOn;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
//import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.ActivityObject;

import anywheresoftware.b4a.BA.Events;

//import android.graphics.Color;

import android.view.View;
import android.widget.TextView;
import android.widget.ImageView;

import java.util.ArrayList;
import java.util.List;

//import android.os.Build;
import android.os.Bundle;
import android.os.Handler;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.view.MotionEvent;
import android.view.View.OnTouchListener;

@ActivityObject
@Events(values={"check_changed(checked As Boolean)"})
@Author("Github: Wallace (Bigmercu), Wrapped by: Johan Schoeman")
@Version(1.00f)
@ShortName("ACheckBox")
//@DependsOn(values={"android-support-v4"})
public class acheckboxWrapper extends ViewWrapper<BBox> implements DesignerCustomView {


	private BA ba;
	private String eventName;
    private BBox cv;
	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new BBox(ba.context, null);
        this.setObject(cv);

		addListener();
 	}
	
	
	public void setChecked(boolean set){
		cv.setChecked(set);
		cv.invalidate();
	}	
	
    public void toggle() {
        cv.toggle();
		cv.invalidate();
    }


    public void setText(String text){
        cv.setText(text);
        cv.invalidate();
    }	
	
	public void setColorAfter(int colorAfter) {
		cv.setColorAfter(colorAfter);
		cv.invalidate();
	}
	
    public void setColorBefore(int colorBefore) {
		cv.setColorBefore(colorBefore);
		cv.invalidate();
	}
	
 	public void isHook(boolean isHook) {
		cv.isHook(isHook);
		cv.invalidate();
	}
 	
	public void isShowBorder(boolean isShowBorder) {
		cv.isShowBorder(isShowBorder);
		cv.invalidate();
	}	
	
	public void setTextColor(int textcolor) {
		cv.setTextColor(textcolor);
		cv.invalidate();
	}	
	
	public void setTextSize(int textsize) {
		cv.setTextSize(textsize);
		cv.invalidate();
	}	
	

    @Hide
    public void addListener(){

        cv.setCallback(new BBox.Callback() {
            @Override
            public void check_changed() {

              if (ba.subExists(eventName + "_check_changed")) {
                ba.raiseEvent2(ba, false, eventName + "_check_changed", true, new Object[]{cv.isChecked()});
              }
            }
			
        });
    }

	
	//programmatically add view
    @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}
	
   
}
